/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import * as cdktf from 'cdktf';
import { OneDashboardPageWidgetArea, OneDashboardPageWidgetAreaList, OneDashboardPageWidgetBar, OneDashboardPageWidgetBarList, OneDashboardPageWidgetBillboard, OneDashboardPageWidgetBillboardList, OneDashboardPageWidgetBullet, OneDashboardPageWidgetBulletList, OneDashboardPageWidgetFunnel, OneDashboardPageWidgetFunnelList, OneDashboardPageWidgetHeatmap, OneDashboardPageWidgetHeatmapList, OneDashboardPageWidgetHistogram, OneDashboardPageWidgetHistogramList, OneDashboardPageWidgetJson, OneDashboardPageWidgetJsonList, OneDashboardPageWidgetLine, OneDashboardPageWidgetLineList, OneDashboardPageWidgetLogTable, OneDashboardPageWidgetLogTableList } from './structs0';
export interface OneDashboardPageWidgetMarkdownColorsSeriesOverrides {
    /**
    * Color code
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetMarkdownColorsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetMarkdownColorsSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetMarkdownColorsSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetMarkdownColorsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetMarkdownColorsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetMarkdownColorsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetMarkdownColorsSeriesOverrides | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetMarkdownColorsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetMarkdownColorsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetMarkdownColorsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetMarkdownColors {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetMarkdownColorsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetMarkdownColorsToTerraform(struct?: OneDashboardPageWidgetMarkdownColors | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetMarkdownColorsToHclTerraform(struct?: OneDashboardPageWidgetMarkdownColors | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetMarkdownColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetMarkdownColors | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetMarkdownColors | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetMarkdownColorsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetMarkdownColorsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetMarkdownColorsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetMarkdownColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetMarkdownColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetMarkdownColorsOutputReference;
}
export interface OneDashboardPageWidgetMarkdownDataFormat {
    /**
    * Defines the format of the mentioned type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#format OneDashboard#format}
    */
    readonly format?: string;
    /**
    * The column name to be sorted
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
    /**
    * The precision of the type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#precision OneDashboard#precision}
    */
    readonly precision?: number;
    /**
    * Defines the type of the mentioned column
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#type OneDashboard#type}
    */
    readonly type: string;
}
export declare function oneDashboardPageWidgetMarkdownDataFormatToTerraform(struct?: OneDashboardPageWidgetMarkdownDataFormat | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetMarkdownDataFormatToHclTerraform(struct?: OneDashboardPageWidgetMarkdownDataFormat | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetMarkdownDataFormatOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetMarkdownDataFormat | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetMarkdownDataFormat | cdktf.IResolvable | undefined);
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _precision?;
    get precision(): number;
    set precision(value: number);
    resetPrecision(): void;
    get precisionInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class OneDashboardPageWidgetMarkdownDataFormatList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetMarkdownDataFormat[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetMarkdownDataFormatOutputReference;
}
export interface OneDashboardPageWidgetMarkdownInitialSorting {
    /**
    * Defines the sort order. Either ascending or descending.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#direction OneDashboard#direction}
    */
    readonly direction: string;
    /**
    * The column name to be sorted
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
}
export declare function oneDashboardPageWidgetMarkdownInitialSortingToTerraform(struct?: OneDashboardPageWidgetMarkdownInitialSortingOutputReference | OneDashboardPageWidgetMarkdownInitialSorting): any;
export declare function oneDashboardPageWidgetMarkdownInitialSortingToHclTerraform(struct?: OneDashboardPageWidgetMarkdownInitialSortingOutputReference | OneDashboardPageWidgetMarkdownInitialSorting): any;
export declare class OneDashboardPageWidgetMarkdownInitialSortingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OneDashboardPageWidgetMarkdownInitialSorting | undefined;
    set internalValue(value: OneDashboardPageWidgetMarkdownInitialSorting | undefined);
    private _direction?;
    get direction(): string;
    set direction(value: string);
    get directionInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export interface OneDashboardPageWidgetMarkdownNullValuesSeriesOverrides {
    /**
    * Null value
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetMarkdownNullValuesSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetMarkdownNullValuesSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetMarkdownNullValuesSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetMarkdownNullValuesSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetMarkdownNullValuesSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetMarkdownNullValuesSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetMarkdownNullValuesSeriesOverrides | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetMarkdownNullValuesSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetMarkdownNullValuesSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetMarkdownNullValuesSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetMarkdownNullValues {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetMarkdownNullValuesSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetMarkdownNullValuesToTerraform(struct?: OneDashboardPageWidgetMarkdownNullValues | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetMarkdownNullValuesToHclTerraform(struct?: OneDashboardPageWidgetMarkdownNullValues | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetMarkdownNullValuesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetMarkdownNullValues | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetMarkdownNullValues | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetMarkdownNullValuesSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetMarkdownNullValuesSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetMarkdownNullValuesSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetMarkdownNullValuesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetMarkdownNullValues[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetMarkdownNullValuesOutputReference;
}
export interface OneDashboardPageWidgetMarkdownUnitsSeriesOverrides {
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
    /**
    * Unit name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
}
export declare function oneDashboardPageWidgetMarkdownUnitsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetMarkdownUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetMarkdownUnitsSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetMarkdownUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetMarkdownUnitsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetMarkdownUnitsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetMarkdownUnitsSeriesOverrides | cdktf.IResolvable | undefined);
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
}
export declare class OneDashboardPageWidgetMarkdownUnitsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetMarkdownUnitsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetMarkdownUnitsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetMarkdownUnits {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetMarkdownUnitsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetMarkdownUnitsToTerraform(struct?: OneDashboardPageWidgetMarkdownUnits | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetMarkdownUnitsToHclTerraform(struct?: OneDashboardPageWidgetMarkdownUnits | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetMarkdownUnitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetMarkdownUnits | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetMarkdownUnits | cdktf.IResolvable | undefined);
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetMarkdownUnitsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetMarkdownUnitsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetMarkdownUnitsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetMarkdownUnitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetMarkdownUnits[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetMarkdownUnitsOutputReference;
}
export interface OneDashboardPageWidgetMarkdown {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#column OneDashboard#column}
    */
    readonly column: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#facet_show_other_series OneDashboard#facet_show_other_series}
    */
    readonly facetShowOtherSeries?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#height OneDashboard#height}
    */
    readonly height?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#ignore_time_range OneDashboard#ignore_time_range}
    */
    readonly ignoreTimeRange?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#legend_enabled OneDashboard#legend_enabled}
    */
    readonly legendEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#refresh_rate OneDashboard#refresh_rate}
    */
    readonly refreshRate?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#row OneDashboard#row}
    */
    readonly row: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#text OneDashboard#text}
    */
    readonly text: string;
    /**
    * A title for the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#width OneDashboard#width}
    */
    readonly width?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#y_axis_left_max OneDashboard#y_axis_left_max}
    */
    readonly yAxisLeftMax?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#y_axis_left_min OneDashboard#y_axis_left_min}
    */
    readonly yAxisLeftMin?: number;
    /**
    * colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#colors OneDashboard#colors}
    */
    readonly colors?: OneDashboardPageWidgetMarkdownColors[] | cdktf.IResolvable;
    /**
    * data_format block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#data_format OneDashboard#data_format}
    */
    readonly dataFormat?: OneDashboardPageWidgetMarkdownDataFormat[] | cdktf.IResolvable;
    /**
    * initial_sorting block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#initial_sorting OneDashboard#initial_sorting}
    */
    readonly initialSorting?: OneDashboardPageWidgetMarkdownInitialSorting;
    /**
    * null_values block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_values OneDashboard#null_values}
    */
    readonly nullValues?: OneDashboardPageWidgetMarkdownNullValues[] | cdktf.IResolvable;
    /**
    * units block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#units OneDashboard#units}
    */
    readonly units?: OneDashboardPageWidgetMarkdownUnits[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetMarkdownToTerraform(struct?: OneDashboardPageWidgetMarkdown | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetMarkdownToHclTerraform(struct?: OneDashboardPageWidgetMarkdown | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetMarkdownOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetMarkdown | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetMarkdown | cdktf.IResolvable | undefined);
    private _column?;
    get column(): number;
    set column(value: number);
    get columnInput(): number | undefined;
    private _facetShowOtherSeries?;
    get facetShowOtherSeries(): boolean | cdktf.IResolvable;
    set facetShowOtherSeries(value: boolean | cdktf.IResolvable);
    resetFacetShowOtherSeries(): void;
    get facetShowOtherSeriesInput(): boolean | cdktf.IResolvable | undefined;
    private _height?;
    get height(): number;
    set height(value: number);
    resetHeight(): void;
    get heightInput(): number | undefined;
    get id(): string;
    private _ignoreTimeRange?;
    get ignoreTimeRange(): boolean | cdktf.IResolvable;
    set ignoreTimeRange(value: boolean | cdktf.IResolvable);
    resetIgnoreTimeRange(): void;
    get ignoreTimeRangeInput(): boolean | cdktf.IResolvable | undefined;
    private _legendEnabled?;
    get legendEnabled(): boolean | cdktf.IResolvable;
    set legendEnabled(value: boolean | cdktf.IResolvable);
    resetLegendEnabled(): void;
    get legendEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _refreshRate?;
    get refreshRate(): string;
    set refreshRate(value: string);
    resetRefreshRate(): void;
    get refreshRateInput(): string | undefined;
    private _row?;
    get row(): number;
    set row(value: number);
    get rowInput(): number | undefined;
    private _text?;
    get text(): string;
    set text(value: string);
    get textInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _yAxisLeftMax?;
    get yAxisLeftMax(): number;
    set yAxisLeftMax(value: number);
    resetYAxisLeftMax(): void;
    get yAxisLeftMaxInput(): number | undefined;
    private _yAxisLeftMin?;
    get yAxisLeftMin(): number;
    set yAxisLeftMin(value: number);
    resetYAxisLeftMin(): void;
    get yAxisLeftMinInput(): number | undefined;
    private _colors;
    get colors(): OneDashboardPageWidgetMarkdownColorsList;
    putColors(value: OneDashboardPageWidgetMarkdownColors[] | cdktf.IResolvable): void;
    resetColors(): void;
    get colorsInput(): cdktf.IResolvable | OneDashboardPageWidgetMarkdownColors[] | undefined;
    private _dataFormat;
    get dataFormat(): OneDashboardPageWidgetMarkdownDataFormatList;
    putDataFormat(value: OneDashboardPageWidgetMarkdownDataFormat[] | cdktf.IResolvable): void;
    resetDataFormat(): void;
    get dataFormatInput(): cdktf.IResolvable | OneDashboardPageWidgetMarkdownDataFormat[] | undefined;
    private _initialSorting;
    get initialSorting(): OneDashboardPageWidgetMarkdownInitialSortingOutputReference;
    putInitialSorting(value: OneDashboardPageWidgetMarkdownInitialSorting): void;
    resetInitialSorting(): void;
    get initialSortingInput(): OneDashboardPageWidgetMarkdownInitialSorting | undefined;
    private _nullValues;
    get nullValues(): OneDashboardPageWidgetMarkdownNullValuesList;
    putNullValues(value: OneDashboardPageWidgetMarkdownNullValues[] | cdktf.IResolvable): void;
    resetNullValues(): void;
    get nullValuesInput(): cdktf.IResolvable | OneDashboardPageWidgetMarkdownNullValues[] | undefined;
    private _units;
    get units(): OneDashboardPageWidgetMarkdownUnitsList;
    putUnits(value: OneDashboardPageWidgetMarkdownUnits[] | cdktf.IResolvable): void;
    resetUnits(): void;
    get unitsInput(): cdktf.IResolvable | OneDashboardPageWidgetMarkdownUnits[] | undefined;
}
export declare class OneDashboardPageWidgetMarkdownList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetMarkdown[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetMarkdownOutputReference;
}
export interface OneDashboardPageWidgetPieColorsSeriesOverrides {
    /**
    * Color code
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetPieColorsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetPieColorsSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetPieColorsSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetPieColorsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetPieColorsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetPieColorsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetPieColorsSeriesOverrides | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetPieColorsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetPieColorsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetPieColorsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetPieColors {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetPieColorsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetPieColorsToTerraform(struct?: OneDashboardPageWidgetPieColors | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetPieColorsToHclTerraform(struct?: OneDashboardPageWidgetPieColors | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetPieColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetPieColors | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetPieColors | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetPieColorsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetPieColorsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetPieColorsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetPieColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetPieColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetPieColorsOutputReference;
}
export interface OneDashboardPageWidgetPieDataFormat {
    /**
    * Defines the format of the mentioned type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#format OneDashboard#format}
    */
    readonly format?: string;
    /**
    * The column name to be sorted
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
    /**
    * The precision of the type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#precision OneDashboard#precision}
    */
    readonly precision?: number;
    /**
    * Defines the type of the mentioned column
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#type OneDashboard#type}
    */
    readonly type: string;
}
export declare function oneDashboardPageWidgetPieDataFormatToTerraform(struct?: OneDashboardPageWidgetPieDataFormat | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetPieDataFormatToHclTerraform(struct?: OneDashboardPageWidgetPieDataFormat | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetPieDataFormatOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetPieDataFormat | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetPieDataFormat | cdktf.IResolvable | undefined);
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _precision?;
    get precision(): number;
    set precision(value: number);
    resetPrecision(): void;
    get precisionInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class OneDashboardPageWidgetPieDataFormatList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetPieDataFormat[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetPieDataFormatOutputReference;
}
export interface OneDashboardPageWidgetPieInitialSorting {
    /**
    * Defines the sort order. Either ascending or descending.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#direction OneDashboard#direction}
    */
    readonly direction: string;
    /**
    * The column name to be sorted
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
}
export declare function oneDashboardPageWidgetPieInitialSortingToTerraform(struct?: OneDashboardPageWidgetPieInitialSortingOutputReference | OneDashboardPageWidgetPieInitialSorting): any;
export declare function oneDashboardPageWidgetPieInitialSortingToHclTerraform(struct?: OneDashboardPageWidgetPieInitialSortingOutputReference | OneDashboardPageWidgetPieInitialSorting): any;
export declare class OneDashboardPageWidgetPieInitialSortingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OneDashboardPageWidgetPieInitialSorting | undefined;
    set internalValue(value: OneDashboardPageWidgetPieInitialSorting | undefined);
    private _direction?;
    get direction(): string;
    set direction(value: string);
    get directionInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export interface OneDashboardPageWidgetPieNrqlQuery {
    /**
    * The account id used for the NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#account_id OneDashboard#account_id}
    */
    readonly accountId?: number;
    /**
    * The NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#query OneDashboard#query}
    */
    readonly query: string;
}
export declare function oneDashboardPageWidgetPieNrqlQueryToTerraform(struct?: OneDashboardPageWidgetPieNrqlQuery | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetPieNrqlQueryToHclTerraform(struct?: OneDashboardPageWidgetPieNrqlQuery | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetPieNrqlQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetPieNrqlQuery | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetPieNrqlQuery | cdktf.IResolvable | undefined);
    private _accountId?;
    get accountId(): number;
    set accountId(value: number);
    resetAccountId(): void;
    get accountIdInput(): number | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    get queryInput(): string | undefined;
}
export declare class OneDashboardPageWidgetPieNrqlQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetPieNrqlQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetPieNrqlQueryOutputReference;
}
export interface OneDashboardPageWidgetPieNullValuesSeriesOverrides {
    /**
    * Null value
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetPieNullValuesSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetPieNullValuesSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetPieNullValuesSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetPieNullValuesSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetPieNullValuesSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetPieNullValuesSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetPieNullValuesSeriesOverrides | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetPieNullValuesSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetPieNullValuesSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetPieNullValuesSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetPieNullValues {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetPieNullValuesSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetPieNullValuesToTerraform(struct?: OneDashboardPageWidgetPieNullValues | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetPieNullValuesToHclTerraform(struct?: OneDashboardPageWidgetPieNullValues | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetPieNullValuesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetPieNullValues | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetPieNullValues | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetPieNullValuesSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetPieNullValuesSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetPieNullValuesSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetPieNullValuesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetPieNullValues[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetPieNullValuesOutputReference;
}
export interface OneDashboardPageWidgetPieUnitsSeriesOverrides {
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
    /**
    * Unit name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
}
export declare function oneDashboardPageWidgetPieUnitsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetPieUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetPieUnitsSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetPieUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetPieUnitsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetPieUnitsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetPieUnitsSeriesOverrides | cdktf.IResolvable | undefined);
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
}
export declare class OneDashboardPageWidgetPieUnitsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetPieUnitsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetPieUnitsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetPieUnits {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetPieUnitsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetPieUnitsToTerraform(struct?: OneDashboardPageWidgetPieUnits | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetPieUnitsToHclTerraform(struct?: OneDashboardPageWidgetPieUnits | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetPieUnitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetPieUnits | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetPieUnits | cdktf.IResolvable | undefined);
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetPieUnitsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetPieUnitsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetPieUnitsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetPieUnitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetPieUnits[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetPieUnitsOutputReference;
}
export interface OneDashboardPageWidgetPie {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#column OneDashboard#column}
    */
    readonly column: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#facet_show_other_series OneDashboard#facet_show_other_series}
    */
    readonly facetShowOtherSeries?: boolean | cdktf.IResolvable;
    /**
    * Use this item to filter the current dashboard
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#filter_current_dashboard OneDashboard#filter_current_dashboard}
    */
    readonly filterCurrentDashboard?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#height OneDashboard#height}
    */
    readonly height?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#ignore_time_range OneDashboard#ignore_time_range}
    */
    readonly ignoreTimeRange?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#legend_enabled OneDashboard#legend_enabled}
    */
    readonly legendEnabled?: boolean | cdktf.IResolvable;
    /**
    * Related entities. Currently only supports Dashboard entities, but may allow other cases in the future.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#linked_entity_guids OneDashboard#linked_entity_guids}
    */
    readonly linkedEntityGuids?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#refresh_rate OneDashboard#refresh_rate}
    */
    readonly refreshRate?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#row OneDashboard#row}
    */
    readonly row: number;
    /**
    * A title for the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#width OneDashboard#width}
    */
    readonly width?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#y_axis_left_max OneDashboard#y_axis_left_max}
    */
    readonly yAxisLeftMax?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#y_axis_left_min OneDashboard#y_axis_left_min}
    */
    readonly yAxisLeftMin?: number;
    /**
    * colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#colors OneDashboard#colors}
    */
    readonly colors?: OneDashboardPageWidgetPieColors[] | cdktf.IResolvable;
    /**
    * data_format block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#data_format OneDashboard#data_format}
    */
    readonly dataFormat?: OneDashboardPageWidgetPieDataFormat[] | cdktf.IResolvable;
    /**
    * initial_sorting block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#initial_sorting OneDashboard#initial_sorting}
    */
    readonly initialSorting?: OneDashboardPageWidgetPieInitialSorting;
    /**
    * nrql_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#nrql_query OneDashboard#nrql_query}
    */
    readonly nrqlQuery: OneDashboardPageWidgetPieNrqlQuery[] | cdktf.IResolvable;
    /**
    * null_values block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_values OneDashboard#null_values}
    */
    readonly nullValues?: OneDashboardPageWidgetPieNullValues[] | cdktf.IResolvable;
    /**
    * units block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#units OneDashboard#units}
    */
    readonly units?: OneDashboardPageWidgetPieUnits[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetPieToTerraform(struct?: OneDashboardPageWidgetPie | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetPieToHclTerraform(struct?: OneDashboardPageWidgetPie | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetPieOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetPie | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetPie | cdktf.IResolvable | undefined);
    private _column?;
    get column(): number;
    set column(value: number);
    get columnInput(): number | undefined;
    private _facetShowOtherSeries?;
    get facetShowOtherSeries(): boolean | cdktf.IResolvable;
    set facetShowOtherSeries(value: boolean | cdktf.IResolvable);
    resetFacetShowOtherSeries(): void;
    get facetShowOtherSeriesInput(): boolean | cdktf.IResolvable | undefined;
    private _filterCurrentDashboard?;
    get filterCurrentDashboard(): boolean | cdktf.IResolvable;
    set filterCurrentDashboard(value: boolean | cdktf.IResolvable);
    resetFilterCurrentDashboard(): void;
    get filterCurrentDashboardInput(): boolean | cdktf.IResolvable | undefined;
    private _height?;
    get height(): number;
    set height(value: number);
    resetHeight(): void;
    get heightInput(): number | undefined;
    get id(): string;
    private _ignoreTimeRange?;
    get ignoreTimeRange(): boolean | cdktf.IResolvable;
    set ignoreTimeRange(value: boolean | cdktf.IResolvable);
    resetIgnoreTimeRange(): void;
    get ignoreTimeRangeInput(): boolean | cdktf.IResolvable | undefined;
    private _legendEnabled?;
    get legendEnabled(): boolean | cdktf.IResolvable;
    set legendEnabled(value: boolean | cdktf.IResolvable);
    resetLegendEnabled(): void;
    get legendEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _linkedEntityGuids?;
    get linkedEntityGuids(): string[];
    set linkedEntityGuids(value: string[]);
    resetLinkedEntityGuids(): void;
    get linkedEntityGuidsInput(): string[] | undefined;
    private _refreshRate?;
    get refreshRate(): string;
    set refreshRate(value: string);
    resetRefreshRate(): void;
    get refreshRateInput(): string | undefined;
    private _row?;
    get row(): number;
    set row(value: number);
    get rowInput(): number | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _yAxisLeftMax?;
    get yAxisLeftMax(): number;
    set yAxisLeftMax(value: number);
    resetYAxisLeftMax(): void;
    get yAxisLeftMaxInput(): number | undefined;
    private _yAxisLeftMin?;
    get yAxisLeftMin(): number;
    set yAxisLeftMin(value: number);
    resetYAxisLeftMin(): void;
    get yAxisLeftMinInput(): number | undefined;
    private _colors;
    get colors(): OneDashboardPageWidgetPieColorsList;
    putColors(value: OneDashboardPageWidgetPieColors[] | cdktf.IResolvable): void;
    resetColors(): void;
    get colorsInput(): cdktf.IResolvable | OneDashboardPageWidgetPieColors[] | undefined;
    private _dataFormat;
    get dataFormat(): OneDashboardPageWidgetPieDataFormatList;
    putDataFormat(value: OneDashboardPageWidgetPieDataFormat[] | cdktf.IResolvable): void;
    resetDataFormat(): void;
    get dataFormatInput(): cdktf.IResolvable | OneDashboardPageWidgetPieDataFormat[] | undefined;
    private _initialSorting;
    get initialSorting(): OneDashboardPageWidgetPieInitialSortingOutputReference;
    putInitialSorting(value: OneDashboardPageWidgetPieInitialSorting): void;
    resetInitialSorting(): void;
    get initialSortingInput(): OneDashboardPageWidgetPieInitialSorting | undefined;
    private _nrqlQuery;
    get nrqlQuery(): OneDashboardPageWidgetPieNrqlQueryList;
    putNrqlQuery(value: OneDashboardPageWidgetPieNrqlQuery[] | cdktf.IResolvable): void;
    get nrqlQueryInput(): cdktf.IResolvable | OneDashboardPageWidgetPieNrqlQuery[] | undefined;
    private _nullValues;
    get nullValues(): OneDashboardPageWidgetPieNullValuesList;
    putNullValues(value: OneDashboardPageWidgetPieNullValues[] | cdktf.IResolvable): void;
    resetNullValues(): void;
    get nullValuesInput(): cdktf.IResolvable | OneDashboardPageWidgetPieNullValues[] | undefined;
    private _units;
    get units(): OneDashboardPageWidgetPieUnitsList;
    putUnits(value: OneDashboardPageWidgetPieUnits[] | cdktf.IResolvable): void;
    resetUnits(): void;
    get unitsInput(): cdktf.IResolvable | OneDashboardPageWidgetPieUnits[] | undefined;
}
export declare class OneDashboardPageWidgetPieList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetPie[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetPieOutputReference;
}
export interface OneDashboardPageWidgetStackedBarColorsSeriesOverrides {
    /**
    * Color code
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetStackedBarColorsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetStackedBarColorsSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetStackedBarColorsSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetStackedBarColorsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarColorsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarColorsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarColorsSeriesOverrides | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetStackedBarColorsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarColorsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarColorsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetStackedBarColors {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetStackedBarColorsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetStackedBarColorsToTerraform(struct?: OneDashboardPageWidgetStackedBarColors | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetStackedBarColorsToHclTerraform(struct?: OneDashboardPageWidgetStackedBarColors | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarColors | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarColors | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetStackedBarColorsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetStackedBarColorsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarColorsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetStackedBarColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarColorsOutputReference;
}
export interface OneDashboardPageWidgetStackedBarDataFormat {
    /**
    * Defines the format of the mentioned type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#format OneDashboard#format}
    */
    readonly format?: string;
    /**
    * The column name to be sorted
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
    /**
    * The precision of the type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#precision OneDashboard#precision}
    */
    readonly precision?: number;
    /**
    * Defines the type of the mentioned column
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#type OneDashboard#type}
    */
    readonly type: string;
}
export declare function oneDashboardPageWidgetStackedBarDataFormatToTerraform(struct?: OneDashboardPageWidgetStackedBarDataFormat | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetStackedBarDataFormatToHclTerraform(struct?: OneDashboardPageWidgetStackedBarDataFormat | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarDataFormatOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarDataFormat | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarDataFormat | cdktf.IResolvable | undefined);
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _precision?;
    get precision(): number;
    set precision(value: number);
    resetPrecision(): void;
    get precisionInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class OneDashboardPageWidgetStackedBarDataFormatList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarDataFormat[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarDataFormatOutputReference;
}
export interface OneDashboardPageWidgetStackedBarInitialSorting {
    /**
    * Defines the sort order. Either ascending or descending.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#direction OneDashboard#direction}
    */
    readonly direction: string;
    /**
    * The column name to be sorted
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
}
export declare function oneDashboardPageWidgetStackedBarInitialSortingToTerraform(struct?: OneDashboardPageWidgetStackedBarInitialSortingOutputReference | OneDashboardPageWidgetStackedBarInitialSorting): any;
export declare function oneDashboardPageWidgetStackedBarInitialSortingToHclTerraform(struct?: OneDashboardPageWidgetStackedBarInitialSortingOutputReference | OneDashboardPageWidgetStackedBarInitialSorting): any;
export declare class OneDashboardPageWidgetStackedBarInitialSortingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OneDashboardPageWidgetStackedBarInitialSorting | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarInitialSorting | undefined);
    private _direction?;
    get direction(): string;
    set direction(value: string);
    get directionInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export interface OneDashboardPageWidgetStackedBarNrqlQuery {
    /**
    * The account id used for the NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#account_id OneDashboard#account_id}
    */
    readonly accountId?: number;
    /**
    * The NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#query OneDashboard#query}
    */
    readonly query: string;
}
export declare function oneDashboardPageWidgetStackedBarNrqlQueryToTerraform(struct?: OneDashboardPageWidgetStackedBarNrqlQuery | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetStackedBarNrqlQueryToHclTerraform(struct?: OneDashboardPageWidgetStackedBarNrqlQuery | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarNrqlQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarNrqlQuery | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarNrqlQuery | cdktf.IResolvable | undefined);
    private _accountId?;
    get accountId(): number;
    set accountId(value: number);
    resetAccountId(): void;
    get accountIdInput(): number | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    get queryInput(): string | undefined;
}
export declare class OneDashboardPageWidgetStackedBarNrqlQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarNrqlQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarNrqlQueryOutputReference;
}
export interface OneDashboardPageWidgetStackedBarNullValuesSeriesOverrides {
    /**
    * Null value
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetStackedBarNullValuesSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetStackedBarNullValuesSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetStackedBarNullValuesSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetStackedBarNullValuesSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarNullValuesSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarNullValuesSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarNullValuesSeriesOverrides | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetStackedBarNullValuesSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarNullValuesSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarNullValuesSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetStackedBarNullValues {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetStackedBarNullValuesSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetStackedBarNullValuesToTerraform(struct?: OneDashboardPageWidgetStackedBarNullValues | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetStackedBarNullValuesToHclTerraform(struct?: OneDashboardPageWidgetStackedBarNullValues | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarNullValuesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarNullValues | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarNullValues | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetStackedBarNullValuesSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetStackedBarNullValuesSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarNullValuesSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetStackedBarNullValuesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarNullValues[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarNullValuesOutputReference;
}
export interface OneDashboardPageWidgetStackedBarUnitsSeriesOverrides {
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
    /**
    * Unit name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
}
export declare function oneDashboardPageWidgetStackedBarUnitsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetStackedBarUnitsSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarUnitsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarUnitsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides | cdktf.IResolvable | undefined);
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
}
export declare class OneDashboardPageWidgetStackedBarUnitsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarUnitsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetStackedBarUnits {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetStackedBarUnitsToTerraform(struct?: OneDashboardPageWidgetStackedBarUnits | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetStackedBarUnitsToHclTerraform(struct?: OneDashboardPageWidgetStackedBarUnits | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarUnitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarUnits | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarUnits | cdktf.IResolvable | undefined);
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetStackedBarUnitsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarUnitsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetStackedBarUnitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarUnits[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarUnitsOutputReference;
}
export interface OneDashboardPageWidgetStackedBar {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#column OneDashboard#column}
    */
    readonly column: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#facet_show_other_series OneDashboard#facet_show_other_series}
    */
    readonly facetShowOtherSeries?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#height OneDashboard#height}
    */
    readonly height?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#ignore_time_range OneDashboard#ignore_time_range}
    */
    readonly ignoreTimeRange?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#legend_enabled OneDashboard#legend_enabled}
    */
    readonly legendEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#refresh_rate OneDashboard#refresh_rate}
    */
    readonly refreshRate?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#row OneDashboard#row}
    */
    readonly row: number;
    /**
    * A title for the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#width OneDashboard#width}
    */
    readonly width?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#y_axis_left_max OneDashboard#y_axis_left_max}
    */
    readonly yAxisLeftMax?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#y_axis_left_min OneDashboard#y_axis_left_min}
    */
    readonly yAxisLeftMin?: number;
    /**
    * colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#colors OneDashboard#colors}
    */
    readonly colors?: OneDashboardPageWidgetStackedBarColors[] | cdktf.IResolvable;
    /**
    * data_format block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#data_format OneDashboard#data_format}
    */
    readonly dataFormat?: OneDashboardPageWidgetStackedBarDataFormat[] | cdktf.IResolvable;
    /**
    * initial_sorting block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#initial_sorting OneDashboard#initial_sorting}
    */
    readonly initialSorting?: OneDashboardPageWidgetStackedBarInitialSorting;
    /**
    * nrql_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#nrql_query OneDashboard#nrql_query}
    */
    readonly nrqlQuery: OneDashboardPageWidgetStackedBarNrqlQuery[] | cdktf.IResolvable;
    /**
    * null_values block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_values OneDashboard#null_values}
    */
    readonly nullValues?: OneDashboardPageWidgetStackedBarNullValues[] | cdktf.IResolvable;
    /**
    * units block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#units OneDashboard#units}
    */
    readonly units?: OneDashboardPageWidgetStackedBarUnits[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetStackedBarToTerraform(struct?: OneDashboardPageWidgetStackedBar | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetStackedBarToHclTerraform(struct?: OneDashboardPageWidgetStackedBar | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBar | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBar | cdktf.IResolvable | undefined);
    private _column?;
    get column(): number;
    set column(value: number);
    get columnInput(): number | undefined;
    private _facetShowOtherSeries?;
    get facetShowOtherSeries(): boolean | cdktf.IResolvable;
    set facetShowOtherSeries(value: boolean | cdktf.IResolvable);
    resetFacetShowOtherSeries(): void;
    get facetShowOtherSeriesInput(): boolean | cdktf.IResolvable | undefined;
    private _height?;
    get height(): number;
    set height(value: number);
    resetHeight(): void;
    get heightInput(): number | undefined;
    get id(): string;
    private _ignoreTimeRange?;
    get ignoreTimeRange(): boolean | cdktf.IResolvable;
    set ignoreTimeRange(value: boolean | cdktf.IResolvable);
    resetIgnoreTimeRange(): void;
    get ignoreTimeRangeInput(): boolean | cdktf.IResolvable | undefined;
    private _legendEnabled?;
    get legendEnabled(): boolean | cdktf.IResolvable;
    set legendEnabled(value: boolean | cdktf.IResolvable);
    resetLegendEnabled(): void;
    get legendEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _refreshRate?;
    get refreshRate(): string;
    set refreshRate(value: string);
    resetRefreshRate(): void;
    get refreshRateInput(): string | undefined;
    private _row?;
    get row(): number;
    set row(value: number);
    get rowInput(): number | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _yAxisLeftMax?;
    get yAxisLeftMax(): number;
    set yAxisLeftMax(value: number);
    resetYAxisLeftMax(): void;
    get yAxisLeftMaxInput(): number | undefined;
    private _yAxisLeftMin?;
    get yAxisLeftMin(): number;
    set yAxisLeftMin(value: number);
    resetYAxisLeftMin(): void;
    get yAxisLeftMinInput(): number | undefined;
    private _colors;
    get colors(): OneDashboardPageWidgetStackedBarColorsList;
    putColors(value: OneDashboardPageWidgetStackedBarColors[] | cdktf.IResolvable): void;
    resetColors(): void;
    get colorsInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarColors[] | undefined;
    private _dataFormat;
    get dataFormat(): OneDashboardPageWidgetStackedBarDataFormatList;
    putDataFormat(value: OneDashboardPageWidgetStackedBarDataFormat[] | cdktf.IResolvable): void;
    resetDataFormat(): void;
    get dataFormatInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarDataFormat[] | undefined;
    private _initialSorting;
    get initialSorting(): OneDashboardPageWidgetStackedBarInitialSortingOutputReference;
    putInitialSorting(value: OneDashboardPageWidgetStackedBarInitialSorting): void;
    resetInitialSorting(): void;
    get initialSortingInput(): OneDashboardPageWidgetStackedBarInitialSorting | undefined;
    private _nrqlQuery;
    get nrqlQuery(): OneDashboardPageWidgetStackedBarNrqlQueryList;
    putNrqlQuery(value: OneDashboardPageWidgetStackedBarNrqlQuery[] | cdktf.IResolvable): void;
    get nrqlQueryInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarNrqlQuery[] | undefined;
    private _nullValues;
    get nullValues(): OneDashboardPageWidgetStackedBarNullValuesList;
    putNullValues(value: OneDashboardPageWidgetStackedBarNullValues[] | cdktf.IResolvable): void;
    resetNullValues(): void;
    get nullValuesInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarNullValues[] | undefined;
    private _units;
    get units(): OneDashboardPageWidgetStackedBarUnitsList;
    putUnits(value: OneDashboardPageWidgetStackedBarUnits[] | cdktf.IResolvable): void;
    resetUnits(): void;
    get unitsInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarUnits[] | undefined;
}
export declare class OneDashboardPageWidgetStackedBarList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBar[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarOutputReference;
}
export interface OneDashboardPageWidgetTableColorsSeriesOverrides {
    /**
    * Color code
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetTableColorsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetTableColorsSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableColorsSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetTableColorsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableColorsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableColorsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableColorsSeriesOverrides | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableColorsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableColorsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableColorsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetTableColors {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetTableColorsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetTableColorsToTerraform(struct?: OneDashboardPageWidgetTableColors | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableColorsToHclTerraform(struct?: OneDashboardPageWidgetTableColors | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableColors | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableColors | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetTableColorsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetTableColorsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetTableColorsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetTableColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableColorsOutputReference;
}
export interface OneDashboardPageWidgetTableDataFormat {
    /**
    * Defines the format of the mentioned type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#format OneDashboard#format}
    */
    readonly format?: string;
    /**
    * The column name to be sorted
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
    /**
    * The precision of the type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#precision OneDashboard#precision}
    */
    readonly precision?: number;
    /**
    * Defines the type of the mentioned column
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#type OneDashboard#type}
    */
    readonly type: string;
}
export declare function oneDashboardPageWidgetTableDataFormatToTerraform(struct?: OneDashboardPageWidgetTableDataFormat | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableDataFormatToHclTerraform(struct?: OneDashboardPageWidgetTableDataFormat | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableDataFormatOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableDataFormat | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableDataFormat | cdktf.IResolvable | undefined);
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _precision?;
    get precision(): number;
    set precision(value: number);
    resetPrecision(): void;
    get precisionInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableDataFormatList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableDataFormat[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableDataFormatOutputReference;
}
export interface OneDashboardPageWidgetTableInitialSorting {
    /**
    * Defines the sort order. Either ascending or descending.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#direction OneDashboard#direction}
    */
    readonly direction: string;
    /**
    * The column name to be sorted
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
}
export declare function oneDashboardPageWidgetTableInitialSortingToTerraform(struct?: OneDashboardPageWidgetTableInitialSortingOutputReference | OneDashboardPageWidgetTableInitialSorting): any;
export declare function oneDashboardPageWidgetTableInitialSortingToHclTerraform(struct?: OneDashboardPageWidgetTableInitialSortingOutputReference | OneDashboardPageWidgetTableInitialSorting): any;
export declare class OneDashboardPageWidgetTableInitialSortingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OneDashboardPageWidgetTableInitialSorting | undefined;
    set internalValue(value: OneDashboardPageWidgetTableInitialSorting | undefined);
    private _direction?;
    get direction(): string;
    set direction(value: string);
    get directionInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export interface OneDashboardPageWidgetTableNrqlQuery {
    /**
    * The account id used for the NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#account_id OneDashboard#account_id}
    */
    readonly accountId?: number;
    /**
    * The NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#query OneDashboard#query}
    */
    readonly query: string;
}
export declare function oneDashboardPageWidgetTableNrqlQueryToTerraform(struct?: OneDashboardPageWidgetTableNrqlQuery | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableNrqlQueryToHclTerraform(struct?: OneDashboardPageWidgetTableNrqlQuery | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableNrqlQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableNrqlQuery | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableNrqlQuery | cdktf.IResolvable | undefined);
    private _accountId?;
    get accountId(): number;
    set accountId(value: number);
    resetAccountId(): void;
    get accountIdInput(): number | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    get queryInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableNrqlQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableNrqlQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableNrqlQueryOutputReference;
}
export interface OneDashboardPageWidgetTableNullValuesSeriesOverrides {
    /**
    * Null value
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetTableNullValuesSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetTableNullValuesSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableNullValuesSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetTableNullValuesSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableNullValuesSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableNullValuesSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableNullValuesSeriesOverrides | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableNullValuesSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableNullValuesSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableNullValuesSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetTableNullValues {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetTableNullValuesSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetTableNullValuesToTerraform(struct?: OneDashboardPageWidgetTableNullValues | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableNullValuesToHclTerraform(struct?: OneDashboardPageWidgetTableNullValues | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableNullValuesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableNullValues | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableNullValues | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetTableNullValuesSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetTableNullValuesSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetTableNullValuesSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetTableNullValuesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableNullValues[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableNullValuesOutputReference;
}
export interface OneDashboardPageWidgetTableThreshold {
    /**
    * Name of the column in the table, to which the threshold would be applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#column_name OneDashboard#column_name}
    */
    readonly columnName?: string;
    /**
    * The number from which the range starts in thresholds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#from OneDashboard#from}
    */
    readonly from?: string;
    /**
    * Severity of the threshold, which would reflect in the widget, in the range of the threshold specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#severity OneDashboard#severity}
    */
    readonly severity?: string;
    /**
    * The number at which the range ends in thresholds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#to OneDashboard#to}
    */
    readonly to?: string;
}
export declare function oneDashboardPageWidgetTableThresholdToTerraform(struct?: OneDashboardPageWidgetTableThreshold | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableThresholdToHclTerraform(struct?: OneDashboardPageWidgetTableThreshold | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableThresholdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableThreshold | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableThreshold | cdktf.IResolvable | undefined);
    private _columnName?;
    get columnName(): string;
    set columnName(value: string);
    resetColumnName(): void;
    get columnNameInput(): string | undefined;
    private _from?;
    get from(): string;
    set from(value: string);
    resetFrom(): void;
    get fromInput(): string | undefined;
    private _severity?;
    get severity(): string;
    set severity(value: string);
    resetSeverity(): void;
    get severityInput(): string | undefined;
    private _to?;
    get to(): string;
    set to(value: string);
    resetTo(): void;
    get toInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableThresholdList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableThreshold[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableThresholdOutputReference;
}
export interface OneDashboardPageWidgetTableUnitsSeriesOverrides {
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
    /**
    * Unit name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
}
export declare function oneDashboardPageWidgetTableUnitsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetTableUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableUnitsSeriesOverridesToHclTerraform(struct?: OneDashboardPageWidgetTableUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableUnitsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableUnitsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableUnitsSeriesOverrides | cdktf.IResolvable | undefined);
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableUnitsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableUnitsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableUnitsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetTableUnits {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetTableUnitsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetTableUnitsToTerraform(struct?: OneDashboardPageWidgetTableUnits | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableUnitsToHclTerraform(struct?: OneDashboardPageWidgetTableUnits | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableUnitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableUnits | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableUnits | cdktf.IResolvable | undefined);
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetTableUnitsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetTableUnitsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetTableUnitsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetTableUnitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableUnits[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableUnitsOutputReference;
}
export interface OneDashboardPageWidgetTable {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#column OneDashboard#column}
    */
    readonly column: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#facet_show_other_series OneDashboard#facet_show_other_series}
    */
    readonly facetShowOtherSeries?: boolean | cdktf.IResolvable;
    /**
    * Use this item to filter the current dashboard
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#filter_current_dashboard OneDashboard#filter_current_dashboard}
    */
    readonly filterCurrentDashboard?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#height OneDashboard#height}
    */
    readonly height?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#ignore_time_range OneDashboard#ignore_time_range}
    */
    readonly ignoreTimeRange?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#legend_enabled OneDashboard#legend_enabled}
    */
    readonly legendEnabled?: boolean | cdktf.IResolvable;
    /**
    * Related entities. Currently only supports Dashboard entities, but may allow other cases in the future.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#linked_entity_guids OneDashboard#linked_entity_guids}
    */
    readonly linkedEntityGuids?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#refresh_rate OneDashboard#refresh_rate}
    */
    readonly refreshRate?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#row OneDashboard#row}
    */
    readonly row: number;
    /**
    * A title for the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#width OneDashboard#width}
    */
    readonly width?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#y_axis_left_max OneDashboard#y_axis_left_max}
    */
    readonly yAxisLeftMax?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#y_axis_left_min OneDashboard#y_axis_left_min}
    */
    readonly yAxisLeftMin?: number;
    /**
    * colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#colors OneDashboard#colors}
    */
    readonly colors?: OneDashboardPageWidgetTableColors[] | cdktf.IResolvable;
    /**
    * data_format block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#data_format OneDashboard#data_format}
    */
    readonly dataFormat?: OneDashboardPageWidgetTableDataFormat[] | cdktf.IResolvable;
    /**
    * initial_sorting block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#initial_sorting OneDashboard#initial_sorting}
    */
    readonly initialSorting?: OneDashboardPageWidgetTableInitialSorting;
    /**
    * nrql_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#nrql_query OneDashboard#nrql_query}
    */
    readonly nrqlQuery: OneDashboardPageWidgetTableNrqlQuery[] | cdktf.IResolvable;
    /**
    * null_values block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#null_values OneDashboard#null_values}
    */
    readonly nullValues?: OneDashboardPageWidgetTableNullValues[] | cdktf.IResolvable;
    /**
    * threshold block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#threshold OneDashboard#threshold}
    */
    readonly threshold?: OneDashboardPageWidgetTableThreshold[] | cdktf.IResolvable;
    /**
    * units block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#units OneDashboard#units}
    */
    readonly units?: OneDashboardPageWidgetTableUnits[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetTableToTerraform(struct?: OneDashboardPageWidgetTable | cdktf.IResolvable): any;
export declare function oneDashboardPageWidgetTableToHclTerraform(struct?: OneDashboardPageWidgetTable | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTable | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTable | cdktf.IResolvable | undefined);
    private _column?;
    get column(): number;
    set column(value: number);
    get columnInput(): number | undefined;
    private _facetShowOtherSeries?;
    get facetShowOtherSeries(): boolean | cdktf.IResolvable;
    set facetShowOtherSeries(value: boolean | cdktf.IResolvable);
    resetFacetShowOtherSeries(): void;
    get facetShowOtherSeriesInput(): boolean | cdktf.IResolvable | undefined;
    private _filterCurrentDashboard?;
    get filterCurrentDashboard(): boolean | cdktf.IResolvable;
    set filterCurrentDashboard(value: boolean | cdktf.IResolvable);
    resetFilterCurrentDashboard(): void;
    get filterCurrentDashboardInput(): boolean | cdktf.IResolvable | undefined;
    private _height?;
    get height(): number;
    set height(value: number);
    resetHeight(): void;
    get heightInput(): number | undefined;
    get id(): string;
    private _ignoreTimeRange?;
    get ignoreTimeRange(): boolean | cdktf.IResolvable;
    set ignoreTimeRange(value: boolean | cdktf.IResolvable);
    resetIgnoreTimeRange(): void;
    get ignoreTimeRangeInput(): boolean | cdktf.IResolvable | undefined;
    private _legendEnabled?;
    get legendEnabled(): boolean | cdktf.IResolvable;
    set legendEnabled(value: boolean | cdktf.IResolvable);
    resetLegendEnabled(): void;
    get legendEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _linkedEntityGuids?;
    get linkedEntityGuids(): string[];
    set linkedEntityGuids(value: string[]);
    resetLinkedEntityGuids(): void;
    get linkedEntityGuidsInput(): string[] | undefined;
    private _refreshRate?;
    get refreshRate(): string;
    set refreshRate(value: string);
    resetRefreshRate(): void;
    get refreshRateInput(): string | undefined;
    private _row?;
    get row(): number;
    set row(value: number);
    get rowInput(): number | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _yAxisLeftMax?;
    get yAxisLeftMax(): number;
    set yAxisLeftMax(value: number);
    resetYAxisLeftMax(): void;
    get yAxisLeftMaxInput(): number | undefined;
    private _yAxisLeftMin?;
    get yAxisLeftMin(): number;
    set yAxisLeftMin(value: number);
    resetYAxisLeftMin(): void;
    get yAxisLeftMinInput(): number | undefined;
    private _colors;
    get colors(): OneDashboardPageWidgetTableColorsList;
    putColors(value: OneDashboardPageWidgetTableColors[] | cdktf.IResolvable): void;
    resetColors(): void;
    get colorsInput(): cdktf.IResolvable | OneDashboardPageWidgetTableColors[] | undefined;
    private _dataFormat;
    get dataFormat(): OneDashboardPageWidgetTableDataFormatList;
    putDataFormat(value: OneDashboardPageWidgetTableDataFormat[] | cdktf.IResolvable): void;
    resetDataFormat(): void;
    get dataFormatInput(): cdktf.IResolvable | OneDashboardPageWidgetTableDataFormat[] | undefined;
    private _initialSorting;
    get initialSorting(): OneDashboardPageWidgetTableInitialSortingOutputReference;
    putInitialSorting(value: OneDashboardPageWidgetTableInitialSorting): void;
    resetInitialSorting(): void;
    get initialSortingInput(): OneDashboardPageWidgetTableInitialSorting | undefined;
    private _nrqlQuery;
    get nrqlQuery(): OneDashboardPageWidgetTableNrqlQueryList;
    putNrqlQuery(value: OneDashboardPageWidgetTableNrqlQuery[] | cdktf.IResolvable): void;
    get nrqlQueryInput(): cdktf.IResolvable | OneDashboardPageWidgetTableNrqlQuery[] | undefined;
    private _nullValues;
    get nullValues(): OneDashboardPageWidgetTableNullValuesList;
    putNullValues(value: OneDashboardPageWidgetTableNullValues[] | cdktf.IResolvable): void;
    resetNullValues(): void;
    get nullValuesInput(): cdktf.IResolvable | OneDashboardPageWidgetTableNullValues[] | undefined;
    private _threshold;
    get threshold(): OneDashboardPageWidgetTableThresholdList;
    putThreshold(value: OneDashboardPageWidgetTableThreshold[] | cdktf.IResolvable): void;
    resetThreshold(): void;
    get thresholdInput(): cdktf.IResolvable | OneDashboardPageWidgetTableThreshold[] | undefined;
    private _units;
    get units(): OneDashboardPageWidgetTableUnitsList;
    putUnits(value: OneDashboardPageWidgetTableUnits[] | cdktf.IResolvable): void;
    resetUnits(): void;
    get unitsInput(): cdktf.IResolvable | OneDashboardPageWidgetTableUnits[] | undefined;
}
export declare class OneDashboardPageWidgetTableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableOutputReference;
}
export interface OneDashboardPage {
    /**
    * The dashboard page's description.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#description OneDashboard#description}
    */
    readonly description?: string;
    /**
    * The dashboard page's name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
    /**
    * widget_area block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_area OneDashboard#widget_area}
    */
    readonly widgetArea?: OneDashboardPageWidgetArea[] | cdktf.IResolvable;
    /**
    * widget_bar block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_bar OneDashboard#widget_bar}
    */
    readonly widgetBar?: OneDashboardPageWidgetBar[] | cdktf.IResolvable;
    /**
    * widget_billboard block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_billboard OneDashboard#widget_billboard}
    */
    readonly widgetBillboard?: OneDashboardPageWidgetBillboard[] | cdktf.IResolvable;
    /**
    * widget_bullet block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_bullet OneDashboard#widget_bullet}
    */
    readonly widgetBullet?: OneDashboardPageWidgetBullet[] | cdktf.IResolvable;
    /**
    * widget_funnel block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_funnel OneDashboard#widget_funnel}
    */
    readonly widgetFunnel?: OneDashboardPageWidgetFunnel[] | cdktf.IResolvable;
    /**
    * widget_heatmap block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_heatmap OneDashboard#widget_heatmap}
    */
    readonly widgetHeatmap?: OneDashboardPageWidgetHeatmap[] | cdktf.IResolvable;
    /**
    * widget_histogram block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_histogram OneDashboard#widget_histogram}
    */
    readonly widgetHistogram?: OneDashboardPageWidgetHistogram[] | cdktf.IResolvable;
    /**
    * widget_json block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_json OneDashboard#widget_json}
    */
    readonly widgetJson?: OneDashboardPageWidgetJson[] | cdktf.IResolvable;
    /**
    * widget_line block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_line OneDashboard#widget_line}
    */
    readonly widgetLine?: OneDashboardPageWidgetLine[] | cdktf.IResolvable;
    /**
    * widget_log_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_log_table OneDashboard#widget_log_table}
    */
    readonly widgetLogTable?: OneDashboardPageWidgetLogTable[] | cdktf.IResolvable;
    /**
    * widget_markdown block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_markdown OneDashboard#widget_markdown}
    */
    readonly widgetMarkdown?: OneDashboardPageWidgetMarkdown[] | cdktf.IResolvable;
    /**
    * widget_pie block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_pie OneDashboard#widget_pie}
    */
    readonly widgetPie?: OneDashboardPageWidgetPie[] | cdktf.IResolvable;
    /**
    * widget_stacked_bar block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_stacked_bar OneDashboard#widget_stacked_bar}
    */
    readonly widgetStackedBar?: OneDashboardPageWidgetStackedBar[] | cdktf.IResolvable;
    /**
    * widget_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#widget_table OneDashboard#widget_table}
    */
    readonly widgetTable?: OneDashboardPageWidgetTable[] | cdktf.IResolvable;
}
export declare function oneDashboardPageToTerraform(struct?: OneDashboardPage | cdktf.IResolvable): any;
export declare function oneDashboardPageToHclTerraform(struct?: OneDashboardPage | cdktf.IResolvable): any;
export declare class OneDashboardPageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPage | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPage | cdktf.IResolvable | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get guid(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _widgetArea;
    get widgetArea(): OneDashboardPageWidgetAreaList;
    putWidgetArea(value: OneDashboardPageWidgetArea[] | cdktf.IResolvable): void;
    resetWidgetArea(): void;
    get widgetAreaInput(): cdktf.IResolvable | OneDashboardPageWidgetArea[] | undefined;
    private _widgetBar;
    get widgetBar(): OneDashboardPageWidgetBarList;
    putWidgetBar(value: OneDashboardPageWidgetBar[] | cdktf.IResolvable): void;
    resetWidgetBar(): void;
    get widgetBarInput(): cdktf.IResolvable | OneDashboardPageWidgetBar[] | undefined;
    private _widgetBillboard;
    get widgetBillboard(): OneDashboardPageWidgetBillboardList;
    putWidgetBillboard(value: OneDashboardPageWidgetBillboard[] | cdktf.IResolvable): void;
    resetWidgetBillboard(): void;
    get widgetBillboardInput(): cdktf.IResolvable | OneDashboardPageWidgetBillboard[] | undefined;
    private _widgetBullet;
    get widgetBullet(): OneDashboardPageWidgetBulletList;
    putWidgetBullet(value: OneDashboardPageWidgetBullet[] | cdktf.IResolvable): void;
    resetWidgetBullet(): void;
    get widgetBulletInput(): cdktf.IResolvable | OneDashboardPageWidgetBullet[] | undefined;
    private _widgetFunnel;
    get widgetFunnel(): OneDashboardPageWidgetFunnelList;
    putWidgetFunnel(value: OneDashboardPageWidgetFunnel[] | cdktf.IResolvable): void;
    resetWidgetFunnel(): void;
    get widgetFunnelInput(): cdktf.IResolvable | OneDashboardPageWidgetFunnel[] | undefined;
    private _widgetHeatmap;
    get widgetHeatmap(): OneDashboardPageWidgetHeatmapList;
    putWidgetHeatmap(value: OneDashboardPageWidgetHeatmap[] | cdktf.IResolvable): void;
    resetWidgetHeatmap(): void;
    get widgetHeatmapInput(): cdktf.IResolvable | OneDashboardPageWidgetHeatmap[] | undefined;
    private _widgetHistogram;
    get widgetHistogram(): OneDashboardPageWidgetHistogramList;
    putWidgetHistogram(value: OneDashboardPageWidgetHistogram[] | cdktf.IResolvable): void;
    resetWidgetHistogram(): void;
    get widgetHistogramInput(): cdktf.IResolvable | OneDashboardPageWidgetHistogram[] | undefined;
    private _widgetJson;
    get widgetJson(): OneDashboardPageWidgetJsonList;
    putWidgetJson(value: OneDashboardPageWidgetJson[] | cdktf.IResolvable): void;
    resetWidgetJson(): void;
    get widgetJsonInput(): cdktf.IResolvable | OneDashboardPageWidgetJson[] | undefined;
    private _widgetLine;
    get widgetLine(): OneDashboardPageWidgetLineList;
    putWidgetLine(value: OneDashboardPageWidgetLine[] | cdktf.IResolvable): void;
    resetWidgetLine(): void;
    get widgetLineInput(): cdktf.IResolvable | OneDashboardPageWidgetLine[] | undefined;
    private _widgetLogTable;
    get widgetLogTable(): OneDashboardPageWidgetLogTableList;
    putWidgetLogTable(value: OneDashboardPageWidgetLogTable[] | cdktf.IResolvable): void;
    resetWidgetLogTable(): void;
    get widgetLogTableInput(): cdktf.IResolvable | OneDashboardPageWidgetLogTable[] | undefined;
    private _widgetMarkdown;
    get widgetMarkdown(): OneDashboardPageWidgetMarkdownList;
    putWidgetMarkdown(value: OneDashboardPageWidgetMarkdown[] | cdktf.IResolvable): void;
    resetWidgetMarkdown(): void;
    get widgetMarkdownInput(): cdktf.IResolvable | OneDashboardPageWidgetMarkdown[] | undefined;
    private _widgetPie;
    get widgetPie(): OneDashboardPageWidgetPieList;
    putWidgetPie(value: OneDashboardPageWidgetPie[] | cdktf.IResolvable): void;
    resetWidgetPie(): void;
    get widgetPieInput(): cdktf.IResolvable | OneDashboardPageWidgetPie[] | undefined;
    private _widgetStackedBar;
    get widgetStackedBar(): OneDashboardPageWidgetStackedBarList;
    putWidgetStackedBar(value: OneDashboardPageWidgetStackedBar[] | cdktf.IResolvable): void;
    resetWidgetStackedBar(): void;
    get widgetStackedBarInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBar[] | undefined;
    private _widgetTable;
    get widgetTable(): OneDashboardPageWidgetTableList;
    putWidgetTable(value: OneDashboardPageWidgetTable[] | cdktf.IResolvable): void;
    resetWidgetTable(): void;
    get widgetTableInput(): cdktf.IResolvable | OneDashboardPageWidgetTable[] | undefined;
}
export declare class OneDashboardPageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageOutputReference;
}
export interface OneDashboardVariableItem {
    /**
    * A human-friendly display string for this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title?: string;
    /**
    * A possible variable value
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#value OneDashboard#value}
    */
    readonly value: string;
}
export declare function oneDashboardVariableItemToTerraform(struct?: OneDashboardVariableItem | cdktf.IResolvable): any;
export declare function oneDashboardVariableItemToHclTerraform(struct?: OneDashboardVariableItem | cdktf.IResolvable): any;
export declare class OneDashboardVariableItemOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardVariableItem | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardVariableItem | cdktf.IResolvable | undefined);
    private _title?;
    get title(): string;
    set title(value: string);
    resetTitle(): void;
    get titleInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class OneDashboardVariableItemList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardVariableItem[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardVariableItemOutputReference;
}
export interface OneDashboardVariableNrqlQuery {
    /**
    * New Relic account ID(s) to issue the query against.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#account_ids OneDashboard#account_ids}
    */
    readonly accountIds?: number[];
    /**
    * NRQL formatted query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#query OneDashboard#query}
    */
    readonly query: string;
}
export declare function oneDashboardVariableNrqlQueryToTerraform(struct?: OneDashboardVariableNrqlQueryOutputReference | OneDashboardVariableNrqlQuery): any;
export declare function oneDashboardVariableNrqlQueryToHclTerraform(struct?: OneDashboardVariableNrqlQueryOutputReference | OneDashboardVariableNrqlQuery): any;
export declare class OneDashboardVariableNrqlQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OneDashboardVariableNrqlQuery | undefined;
    set internalValue(value: OneDashboardVariableNrqlQuery | undefined);
    private _accountIds?;
    get accountIds(): number[];
    set accountIds(value: number[]);
    resetAccountIds(): void;
    get accountIdsInput(): number[] | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    get queryInput(): string | undefined;
}
export interface OneDashboardVariableOptions {
    /**
    * Only applies to variables of type NRQL. With this turned on, query condition defined with the variable will not be included in the query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#excluded OneDashboard#excluded}
    */
    readonly excluded?: boolean | cdktf.IResolvable;
    /**
    * Only applies to variables of type NRQL. With this turned on, the time range for the NRQL query will override the time picker on dashboards and other pages. Turn this off to use the time picker as normal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#ignore_time_range OneDashboard#ignore_time_range}
    */
    readonly ignoreTimeRange?: boolean | cdktf.IResolvable;
}
export declare function oneDashboardVariableOptionsToTerraform(struct?: OneDashboardVariableOptions | cdktf.IResolvable): any;
export declare function oneDashboardVariableOptionsToHclTerraform(struct?: OneDashboardVariableOptions | cdktf.IResolvable): any;
export declare class OneDashboardVariableOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardVariableOptions | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardVariableOptions | cdktf.IResolvable | undefined);
    private _excluded?;
    get excluded(): boolean | cdktf.IResolvable;
    set excluded(value: boolean | cdktf.IResolvable);
    resetExcluded(): void;
    get excludedInput(): boolean | cdktf.IResolvable | undefined;
    private _ignoreTimeRange?;
    get ignoreTimeRange(): boolean | cdktf.IResolvable;
    set ignoreTimeRange(value: boolean | cdktf.IResolvable);
    resetIgnoreTimeRange(): void;
    get ignoreTimeRangeInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class OneDashboardVariableOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardVariableOptions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardVariableOptionsOutputReference;
}
export interface OneDashboardVariable {
    /**
    * Default values for this variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#default_values OneDashboard#default_values}
    */
    readonly defaultValues?: string[];
    /**
    * Indicates whether this variable supports multiple selection or not. Only applies to variables of type NRQL or ENUM.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#is_multi_selection OneDashboard#is_multi_selection}
    */
    readonly isMultiSelection?: boolean | cdktf.IResolvable;
    /**
    * The variable identifier.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
    /**
    * Indicates the strategy to apply when replacing a variable in a NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#replacement_strategy OneDashboard#replacement_strategy}
    */
    readonly replacementStrategy: string;
    /**
    * Human-friendly display string for this variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title: string;
    /**
    * Specifies the data type of the variable and where its possible values may come from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#type OneDashboard#type}
    */
    readonly type: string;
    /**
    * item block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#item OneDashboard#item}
    */
    readonly item?: OneDashboardVariableItem[] | cdktf.IResolvable;
    /**
    * nrql_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#nrql_query OneDashboard#nrql_query}
    */
    readonly nrqlQuery?: OneDashboardVariableNrqlQuery;
    /**
    * options block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.53.0/docs/resources/one_dashboard#options OneDashboard#options}
    */
    readonly options?: OneDashboardVariableOptions[] | cdktf.IResolvable;
}
export declare function oneDashboardVariableToTerraform(struct?: OneDashboardVariable | cdktf.IResolvable): any;
export declare function oneDashboardVariableToHclTerraform(struct?: OneDashboardVariable | cdktf.IResolvable): any;
export declare class OneDashboardVariableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardVariable | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardVariable | cdktf.IResolvable | undefined);
    private _defaultValues?;
    get defaultValues(): string[];
    set defaultValues(value: string[]);
    resetDefaultValues(): void;
    get defaultValuesInput(): string[] | undefined;
    private _isMultiSelection?;
    get isMultiSelection(): boolean | cdktf.IResolvable;
    set isMultiSelection(value: boolean | cdktf.IResolvable);
    resetIsMultiSelection(): void;
    get isMultiSelectionInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _replacementStrategy?;
    get replacementStrategy(): string;
    set replacementStrategy(value: string);
    get replacementStrategyInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _item;
    get item(): OneDashboardVariableItemList;
    putItem(value: OneDashboardVariableItem[] | cdktf.IResolvable): void;
    resetItem(): void;
    get itemInput(): cdktf.IResolvable | OneDashboardVariableItem[] | undefined;
    private _nrqlQuery;
    get nrqlQuery(): OneDashboardVariableNrqlQueryOutputReference;
    putNrqlQuery(value: OneDashboardVariableNrqlQuery): void;
    resetNrqlQuery(): void;
    get nrqlQueryInput(): OneDashboardVariableNrqlQuery | undefined;
    private _options;
    get options(): OneDashboardVariableOptionsList;
    putOptions(value: OneDashboardVariableOptions[] | cdktf.IResolvable): void;
    resetOptions(): void;
    get optionsInput(): cdktf.IResolvable | OneDashboardVariableOptions[] | undefined;
}
export declare class OneDashboardVariableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardVariable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardVariableOutputReference;
}
